searchData={"items":[{"type":"module","title":"MultiSort","doc":"Documentation for `MultiSort`.","ref":"MultiSort.html"},{"type":"function","title":"MultiSort.by/2","doc":"Sort an enum according to a priortized list of comparators. Inspired by Ecto/SQL order by.\n\nSort posts first by title and then by descending date:\n    posts\n    |> MultiSort.by([\n        {:asc, &1.title}\n        # Pass Date module as third element because we need to use Date.compare/2 to compare dates\n        {:desc, &1.date, Date},\n    ])\n\nSort posts first by category according to order list and then by title:\n    post_category_order = [:business, :sports, :politics]\n    posts\n    |> MultiSort.by([\n        {:asc, &1.category, post_category_order},\n        {:asc, &1.title}\n    ])\n\nThe third element of the tuple can either be:\n- Left out entirely, resuting in the default elixir comparison\n- Be a module with a compare/2 function\n- Be a function that takes 2 arguemnts and returns :eq, :lt, or :gt\n- Be a list that describes sort order","ref":"MultiSort.html#by/2"},{"type":"function","title":"MultiSort.compound_comparator/1","doc":"","ref":"MultiSort.html#compound_comparator/1"},{"type":"type","title":"MultiSort.comparator/0","doc":"","ref":"MultiSort.html#t:comparator/0"},{"type":"type","title":"MultiSort.compare_fn/0","doc":"","ref":"MultiSort.html#t:compare_fn/0"},{"type":"type","title":"MultiSort.map_fn/0","doc":"","ref":"MultiSort.html#t:map_fn/0"},{"type":"type","title":"MultiSort.order/0","doc":"","ref":"MultiSort.html#t:order/0"},{"type":"extras","title":"MultiSort","doc":"# MultiSort\n\n[![Build Status](https://github.com/grantwest/multi_sort/actions/workflows/ci.yml/badge.svg)](https://github.com/grantwest/multi_sort/actions/workflows/ci.yml)\n[![Version](https://img.shields.io/hexpm/v/multi_sort.svg)](https://hex.pm/packages/multi_sort)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/multi_sort/)\n[![Download](https://img.shields.io/hexpm/dt/multi_sort.svg)](https://hex.pm/packages/multi_sort)\n[![License](https://img.shields.io/badge/License-0BSD-blue.svg)](https://opensource.org/licenses/0bsd)\n[![Last Updated](https://img.shields.io/github/last-commit/grantwest/multi_sort.svg)](https://github.com/grantwest/multi_sort/commits/master)\n\nEasily sort by multiple fields in a readable manner. Inspired by Ecto/SQL order by.\n\nSort posts first by title and then by descending date:\n\n```elixir\nposts\n|> MultiSort.by([\n    {:asc, &1.title}\n    # Pass Date module as third element because we need to use Date.compare/2 to compare dates\n    {:desc, &1.date, Date},\n])\n```\n\nSort posts first by category according to order list and then by title:\n\n```elixir\npost_category_order = [:business, :sports, :politics]\nposts\n|> MultiSort.by([\n    {:asc, &1.category, post_category_order},\n    {:asc, &1.title}\n])\n```\n\n[See docs](https://hexdocs.pm/multi_sort/MultiSort.html) for more information and examples.","ref":"readme.html"}],"content_type":"text/markdown"}